//
//  SettingsViewController.m
//  Fast Draft
//
//  Created by Anton on 11.03.13.
//  Copyright (c) 2013 Geometros Company. All rights reserved.
//

#import "SettingsViewController.h"

#import "CommonStructs.h"

@interface SettingsViewController ()

@end

@implementation SettingsViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	
    _LineWidthControl.selectedSegmentIndex = [Drawer GetLinesWidth]-1;
    _LineStyleControl.selectedSegmentIndex = [Drawer GetLinesStyle];
    
    SG_TEXT_STYLE   ts = [Drawer GetTextStyle];

    _FontAngleSlider.value = ts.angle;
    _FontSizeSlider.value = ts.height;
    
    int curF = sgFontManager::GetCurrentFont();
    
    if (curF<6)
    {
        _secondFontBlock.selectedSegmentIndex = -1;
        _firstFontBlock.selectedSegmentIndex = curF;
    }
    else
    {
        _firstFontBlock.selectedSegmentIndex = -1;
        _secondFontBlock.selectedSegmentIndex  = curF-6;
    }
    
}

- (IBAction)closeSettings:(id)sender {
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)FontSizeChange:(id)sender
{
    SG_TEXT_STYLE   ts = [Drawer GetTextStyle];
    UISlider*  sldr = (UISlider*)sender;
    ts.height = sldr.value;
    [Drawer SetTextStyle:ts];
    [_preview redrawPreview];
}

- (IBAction)FontAngleChange:(id)sender
{
    SG_TEXT_STYLE   ts = [Drawer GetTextStyle];
    UISlider*  sldr = (UISlider*)sender;
    ts.angle = sldr.value;
    [Drawer SetTextStyle:ts];
    [_preview redrawPreview];
}

- (IBAction)firstBlockFontChange:(id)sender
{
    UISegmentedControl* segC = (UISegmentedControl*)sender;
    sgFontManager::SetCurrentFont(segC.selectedSegmentIndex);
    [_preview redrawPreview];
    [_secondFontBlock setSelectedSegmentIndex:-1];
}

- (IBAction)secondBlockFontChange:(id)sender
{
    UISegmentedControl* segC = (UISegmentedControl*)sender;
    sgFontManager::SetCurrentFont(segC.selectedSegmentIndex+6);
    [_preview redrawPreview];
    [_firstFontBlock setSelectedSegmentIndex:-1];

}

- (IBAction)widthChange:(id)sender
{
    UISegmentedControl* segC = (UISegmentedControl*)sender;
    [Drawer SetLinesWidth:(segC.selectedSegmentIndex+1)];
    [_preview redrawPreview];

}

- (IBAction)styleChange:(id)sender
{
    UISegmentedControl* segC = (UISegmentedControl*)sender;
    [Drawer SetLinesStyle:(segC.selectedSegmentIndex)];
    [_preview redrawPreview];

}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidUnload {
    [self setPreview:nil];
    [self setFirstFontBlock:nil];
    [self setSecondFontBlock:nil];
    [self setLineWidthControl:nil];
    [self setLineStyleControl:nil];
    [self setFontSizeSlider:nil];
    [self setFontAngleSlider:nil];
    [super viewDidUnload];
}
@end
