//
//  ViewController.m
//  Fast Draft
//
//  Created by AR on 21.02.13.
//  Copyright (c) 2013 Geometros Company. All rights reserved.
//

#import "ViewController.h"


@interface ViewController ()
{
    NSMutableArray*    commands;
    int                currentCommandIndex;
    
    id<ISnapManager>   snapManager;
}

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    commands = [[NSMutableArray alloc] init];
    [commands addObject:[[LineCommand alloc] initWithManager:self] ];
    [commands addObject:[[CircleCommand alloc] initWithManager:self] ];
    [commands addObject:[[ArcCommand alloc] initWithManager:self] ];
    [commands addObject:[[TextCommand alloc] initWithManager:self] ];
    [commands addObject:[[DimCommand alloc] initWithManager:self] ];


    currentCommandIndex = 0;
    
    snapManager = nil;
    
    [_mainView setCommandsManager:self];

}

-(void)               setSnapManager:(id<ISnapManager>)sm
{
    snapManager = sm;
}
-(id<ISnapManager>)   getSnapManager
{
    return snapManager;
}


-(int)            getCommandsCount
{
    return commands.count;
}
-(int)            getCurrentCommand
{
    return currentCommandIndex;
}

-(id<ICommand>)   getCommand:(int)commInd
{
    if (commInd<0 || commInd>=commands.count)
        return nil;
    
    return [commands objectAtIndex:commInd];
}

-(void)               redrawViews
{
    [_mainView redrawAll];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

- (IBAction)ToolBtnPress:(id)sender
{
    if (_menu.isOpen)
        return [_menu close];
    
    // Sample icons from http://icons8.com/download-free-icons-for-ios-tab-bar
    //
    
    REMenuItem*   menuItem[5];
    
    for (int i=0;i<commands.count;i++)
    {
        id<ICommand>  tmpComm = [commands objectAtIndex:i];
        menuItem[i] = [[REMenuItem alloc] initWithTitle:[tmpComm getCommandDescription]
                                                        subtitle:nil
                                                           image:[tmpComm getCommandIcon]
                                                highlightedImage:nil
                                                          action:^(REMenuItem *item) {
                                                              currentCommandIndex = item.tag;
                                                              [_toolBtn  setImage:[tmpComm getCommandIcon] forState:UIControlStateNormal];
                                                          }];
         menuItem[i].tag = i;

    }

    _menu = [[REMenu alloc] initWithItems:@[menuItem[0], menuItem[1], menuItem[2], menuItem[3], menuItem[4]]];
    _menu.cornerRadius = 10;
    _menu.shadowColor = [UIColor blackColor];
    _menu.shadowOffset = CGSizeMake(0, 1);
    _menu.shadowOpacity = 1;
    _menu.imageOffset = CGSizeMake(5, -1);
    
    [_menu showFromView:_toolsbarView andX:53];
}

- (IBAction)ClearBtnPress:(id)sender
{
    [_mainView Clear];
}

- (void)viewDidUnload {
    [self setToolsbarView:nil];
    [self setMainView:nil];
    [self setToolBtn:nil];
    [super viewDidUnload];
}
@end
